
Ruby - Bug #13670

[BUG] Bus Error at 0xefce7b (armv7l) (ruby 2.3.4p301)

06/22/2017 06:02 PM - mrohnstock (Mathias Rohnstock)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.3.4p301 (2017-03-30 revision

58214) [armv7l-linux-eabihf]

Backport: 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4:

UNKNOWN

Description

On using the library bootsnap the error occurred (see attachment). The developer of the library suggested to report this directly to the

ruby-devs, as it looks like a bug in core. Related issue on GitHub: https://github.com/Shopify/bootsnap/issues/67.

Thanks :).

Related issues:

Related to Ruby - Bug #14740: You may have encountered a bug in the Ruby inte... Closed

Related to Ruby - Bug #14789: Debian 9, ARM, rails 5.2.0 not works. Third Party's Issue

History

#1 - 07/06/2017 06:54 PM - WarheadsSE (Jason Plum)

mrohnstock (Mathias Rohnstock) wrote:

On using the library bootsnap the error occurred (see attachment). The developer of the library suggested to report this directly to the ruby-devs,

as it looks like a bug in core. Related issue on GitHub: https://github.com/Shopify/bootsnap/issues/67.

Thanks :).

 GitLab is experiencing this with ruby 2.3.3p222 (2016-11-21 revision 56859) [armv6l-linux-eabihf]

#2 - 09/01/2017 07:14 PM - naruse (Yui NARUSE)

Could you try trunk or Ruby 2.4.1 and provide how to reproduce the issue?

I have armv7l-linux-eabihf environment and I'll try it.

#3 - 12/19/2017 12:30 AM - splitice (Mathew Heard)

Can confirm this occurs with 2.4.1, just install bootsnap and try and launch a rails application.

Tested on a H3 (armv7l)

#4 - 04/11/2018 10:22 PM - fig (Phil Ferne)

Can confirm this still happening in 2.5.1

ruby 2.5.1p57 (2018-03-29 revision 63029) [armv7l-linux-eabihf]

bootsnap (1.3.0)

Rails 5.2.0

 Rails adds bootsnap to a new app by default as of version 5.2.0

any call to rails (rails console, rails server, rails credentials:edit, etc) produces

bootsnap-1.3.0/lib/bootsnap/compile_cache/iseq.rb:18: [BUG] Bus Error at 0x55ae31f7

 

Temporary fix for Rails >= 5.2.0

edit config/boot.rb

comment out or remove the following line:

require 'bootsnap/setup' # Speed up boot time by caching expensive operations.

#5 - 04/12/2018 02:34 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Feedback
https://github.com/Shopify/bootsnap/issues/67
https://github.com/Shopify/bootsnap/issues/67


RubyVM::InstructionSequence#to_binary and RubyVM::InstructionSequence.load_from_binary had bugs around word alignments.

I think the trunk has been fixed, couldn't you try it?

#6 - 04/12/2018 07:52 PM - fig (Phil Ferne)

nobu (Nobuyoshi Nakada) wrote:

RubyVM::InstructionSequence#to_binary and RubyVM::InstructionSequence.load_from_binary had bugs around word alignments.

I think the trunk has been fixed, couldn't you try it?

 Getting 3 failures from make check

  1) Failure:

DRbTests::TestDRbCore#test_07_public_missing [/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:219]:

[NoMethodError] exception expected, not.

Class: <DRb::DRbRemoteError>

Message: <"undefined method `undefined_method_test' for #<DRbTests::DRbEx:0x552ea210> (NoMethodError)">

---Backtrace---

(druby://localhost:33367) /home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/ut_drb.rb:138:in `method_missing'

(druby://localhost:33367) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1640:in `perform_without_block'

(druby://localhost:33367) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1600:in `perform'

(druby://localhost:33367) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1684:in `block (2 levels) in ma

in_loop'

(druby://localhost:33367) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1680:in `loop'

(druby://localhost:33367) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1680:in `block in main_loop'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:220:in `block in test_07_public_missing'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/lib/test/unit/assertions.rb:74:in `assert_raise'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:219:in `test_07_public_missing'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/lib/test/unit.rb:1168:in `run_test'

---------------

 
  2) Failure:

DRbTests::TestDRbSSLCore#test_07_public_missing [/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:219

]:

[NoMethodError] exception expected, not.

Class: <DRb::DRbRemoteError>

Message: <"undefined method `undefined_method_test' for #<DRbTests::DRbEx:0x55593978> (NoMethodError)">

---Backtrace---

(drbssl://localhost:37763) /home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/ut_drb.rb:138:in `method_missing'

(drbssl://localhost:37763) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1640:in `perform_without_block

'

(drbssl://localhost:37763) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1600:in `perform'

(drbssl://localhost:37763) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1684:in `block (2 levels) in m

ain_loop'

(drbssl://localhost:37763) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1680:in `loop'

(drbssl://localhost:37763) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1680:in `block in main_loop'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:220:in `block in test_07_public_missing'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/lib/test/unit/assertions.rb:74:in `assert_raise'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:219:in `test_07_public_missing'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/lib/test/unit.rb:1168:in `run_test'

---------------

 
  3) Failure:

DRbTests::TestDRbUNIXCore#test_07_public_missing [/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:21

9]:

[NoMethodError] exception expected, not.

Class: <DRb::DRbRemoteError>

Message: <"undefined method `undefined_method_test' for #<DRbTests::DRbEx:0x55dc49a8> (NoMethodError)">

---Backtrace---

(drbunix:/tmp/druby32002.0) /home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/ut_drb.rb:138:in `method_missing'

(drbunix:/tmp/druby32002.0) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1640:in `perform_without_bloc

k'

(drbunix:/tmp/druby32002.0) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1600:in `perform'

(drbunix:/tmp/druby32002.0) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1684:in `block (2 levels) in 

main_loop'

(drbunix:/tmp/druby32002.0) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1680:in `loop'

(drbunix:/tmp/druby32002.0) /home/pi/.rbenv/versions/2.6.0-t/ruby/lib/drb/drb.rb:1680:in `block in main_loop'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:220:in `block in test_07_public_missing'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/lib/test/unit/assertions.rb:74:in `assert_raise'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/drb/drbtest.rb:219:in `test_07_public_missing'

/home/pi/.rbenv/versions/2.6.0-t/ruby/test/lib/test/unit.rb:1168:in `run_test'

---------------

 
Finished tests in 2414.375346s, 8.0257 tests/s, 941.3039 assertions/s.
19377 tests, 2272661 assertions, 3 failures, 0 errors, 101 skips

ruby -v: ruby 2.6.0dev (2018-04-12 trunk 63136) [armv7l-linux-eabihf]

uncommon.mk:738: recipe for target 'yes-test-almost' failed

make: *** [yes-test-almost] Error 3

#7 - 04/13/2018 01:50 AM - fig (Phil Ferne)

Disregard the failed tests above - second build installed okay.

Still hitting the bug very occasionally, but finding it very hard to reproduce reliably.

#8 - 05/07/2018 08:54 AM - wanabe (_ wanabe)

- Related to Bug #14740: You may have encountered a bug in the Ruby interpreter or extension libraries. Bug reports are welcome. added

#9 - 05/28/2018 10:21 PM - wanabe (_ wanabe)

- Related to Bug #14789: Debian 9, ARM, rails 5.2.0 not works. added

#10 - 06/21/2018 08:10 AM - splitice (Mathew Heard)

Issue still exists with 2.5.1

The error message has changed however, it now crashes.

[ 3322.842162] Alignment trap: not handling instruction ed920b01 at [<006406f4>]

[ 3322.842177] Unhandled fault: alignment exception (0x001) at 0xb5ba70e3

[ 3322.842182] pgd = d81c8000

[ 3322.842186] [b5ba70e3] *pgd=5a4d9835, *pte=5530055f, *ppte=55300c7e

#11 - 07/31/2020 09:26 AM - vo.x (Vit Ondruch)

This was resolved in Ruby 2.6+, wasn't it? This ticket 1 references following commits which resolves the issue:

https://github.com/ruby/ruby/commit/58a2084483ce8baaf90d7b1cb00e3fa9570fbc79

https://github.com/ruby/ruby/commit/b6185e175cfac5bb8b56483c1b03997923af634e

#12 - 09/11/2020 06:40 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Feedback to Closed

Files
